#!/usr/bin/perl
#
# IISscanor version 0.1 beta
# coded by ZinkerOne
#
use IO::Socket;


sub init {
 print "\n IISscanor version 0.1 beta\n coded by ZinkerOne\n\n";
 
 if ($#ARGV eq 1) {
  $hostfile = $ARGV[0];
  $logfile = $ARGV[1];
 } else {
  die " usage: iisscan.pl <hostfile> <logfile>\n";
 }

}

sub openfiles {

 open _HOSTS, $hostfile || die "\n cannot open $hostfile!\n";
 
 $counter = -1;

 while (<_HOSTS>) {
  $counter++; 
  $c = tr/"\n"//d;	#kill cr
  @hosts[$counter] = $_;
 }
  
 close _HOSTS;

}

sub connecttoserver {
	$bool = "yes";
	
	$socket = IO::Socket::INET->new (   PeerAddr    => $host,
      	                              PeerPort      => $port,
	                                    Proto       => "tcp",
                                            Timeout             => 10,
	                                    Type        => SOCK_STREAM
	                                ) || { $bool = "no"  };
	                                          
	                                	                                    
	return($bool);
}

sub startscan {

 open _LOG, ">>$logfile" || die "\n cannot open $logfile!\n";
 
 $port = 80;
 
 foreach $host (@hosts) {

  print "\n Connecting to $host...";
  $boolean = connecttoserver();

  if ($boolean eq "yes") {
   print " connected.";
   print $socket "GET indx.html HTTP/1.0\r\n\n";
   
   for ($i=0;$i<12;$i++) {
   
   $response = <$socket>;
   $result = index $response, "Server:";
    if ($result != -1) { 
     $result = substr $response,8;
     print $result;
     $res = index $response, "Microsoft-IIS";
     print _LOG "$host -> $result";
     if ($res != -1) {
      print _LOG " -> YEP!\n";
     } else {
      print _LOG " -> NOPE!\n";
     }
   
    }
    
   }
  
  }
 
 }

}

init();
openfiles();
startscan();